---
schema_version: "1"
id: 05e28c2b1eb63550920436455d220e26bb555452523ec001a95dbeb15cb95780
title: Custom Properties
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/commerce-cloud/commerce-api/guides/custom-properties.md
canonical_url: https://developer.salesforce.com/docs/commerce/pwa-kit-managed-runtime/guide/custom-properties.html
source_site: developer.salesforce.com
content_type: documentation
content_hash: be767216cfa418c90033cfaad00f96486c708d210e3428fb40b3351a03e6d73d
products:
  - Composable Storefront
  - Salesforce APIs
---
# Custom Properties

Use SCAPI to set custom properties of business objects in input documents and to read custom properties in output documents. Whether a business object supports custom properties can be found in the [following tables](#document-types-supporting-custom-properties).
Custom properties are always marked with the prefix `c_` and have therefore their own namespace.

## Custom Properties Example

The following example shows a document response including some custom properties:

```txt
REQUEST: GET /product/shopper-products/v1/organizations/ORG_ID/products/creative-zen-v HTTP/1.1
Host: SHORTCODE.api.commercecloud.salesforce.com
Accept: application/json

RESPONSE: HTTP/1.1 200 OK
Content-Type:  application/json; charset=UTF-8
Cache-Control:  max-age=900,must-revalidate
{
   ...
   "c_mediaFormat" : [ "0010", "0020", "0030", "0040" ],
   "c_memorySize" : "1GB",
   "c_tabDescription" : "The ZEN V player was designed for people like you those who walk a step or two ahead of the pack."
}
```

## Custom Properties Value Types

SCAPI supports the following value types for input and output of custom properties:

- Text
- String
- Enum of Strings
- Set of Strings
- Integer
- Enum of Integers
- Set of Integers
- Double
- Set of Doubles
- Boolean
- EMail
- Password
- Date
- Date+Time

**note:** The value types **HTML** and **Image** are only supported as output, but not as input value type for custom properties in SCAPI.

## Document Types Supporting Custom Properties

The following tables list the document types that support custom properties. Hooks (`modify...`) that use the referenced document types can
add custom properties using the `c_` prefix. See [Customization With Hooks](https://developer.salesforce.com/docs/commerce/commerce-api/guide/extensibility_via_hooks.html) for more information.

### Shopper API

The following Shopper API documents support custom properties.

| Document Type                    | Reference                                                                                                                                                                 |
| -------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| Basket v1                        | [Basket v1](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-baskets?meta=type%3ABasket)                                                    |
| Basket v2                        | [Basket v2](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-baskets-v2?meta=type%3ABasket)                                                 |
| BasketPaymentInstrumentRequest   | [BasketPaymentInstrumentRequest](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-baskets?meta=type%3ABasketPaymentInstrumentRequest)       |
| BonusDiscountLineItem            | [BonusDiscountLineItem](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-baskets?meta=type%3ABonusDiscountLineItem)                         |
| Category                         | [Category](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-products?meta=type%3ACategory)                                                  |
| CouponItem                       | [CouponItem](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-baskets?meta=type%3ACouponItem)                                               |
| CustomObject                     | [customObject](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-custom-objects?meta=type%3AcustomObject)                                    |
| Customer                         | [Customer](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-customers?meta=type%3ACustomer)                                                 |
| CustomerAddress                  | [CustomerAddress](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-customers?meta=type%3ACustomerAddress)                                   |
| CustomerInfo                     | [CustomerInfo](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-baskets?meta=type%3ACustomerInfo)                                           |
| CustomerPaymentInstrument        | [CustomerPaymentInstrument](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-customers?meta=type%3ACustomerPaymentInstrument)               |
| CustomerPaymentInstrumentRequest | [CustomerPaymentInstrumentRequest](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-customers?meta=type%3ACustomerPaymentInstrumentRequest) |
| CustomerProductList              | [CustomerProductList](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-customers?meta=type%3ACustomerProductList)                           |
| CustomerProductListItem          | [CustomerProductListItem](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-customers?meta=type%3ACustomerProductListItem)                   |
| CustomerProductListItemPurchase  | [CustomerProductListItemPurchase](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-customers?meta=type%3ACustomerProductListItemPurchase)   |
| GiftCertificate                  | [GiftCertificate](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-gift-certificates?meta=type%3AGiftCertificate)                           |
| GiftCertificateItem              | [GiftCertificateItem](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-baskets?meta=type%3AGiftCertificateItem)                             |
| OptionItem                       | [OptionItem](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-customers?meta=type%3AOptionItem)                                             |
| Order                            | [Order](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-orders?meta=type%3AOrder)                                                          |
| OrderAddress                     | [OrderAddress](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-baskets?meta=type%3AOrderAddress)                                           |
| OrderPaymentInstrument           | [OrderPaymentInstrument](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-baskets?meta=type%3AOrderPaymentInstrument)                       |
| OrderPaymentInstrumentRequest    | [OrderPaymentInstrumentRequest](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-baskets?meta=type%3AOrderPaymentInstrumentRequest)         |
| PathRecord                       | [PathRecord](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-products?meta=type%3APathRecord)                                              |
| PaymentCardSpec                  | [PaymentCardSpec](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-orders?meta=type%3APaymentCardSpec)                                      |
| PaymentMethod                    | [PaymentMethod](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-orders?meta=type%3APaymentMethod))                                         |
| PriceAdjustment                  | [PriceAdjustment](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-orders?meta=type%3APriceAdjustment)                                      |
| PriceAdjustmentRequest           | [PriceAdjustmentRequest](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-orders?meta=type%3APriceAdjustmentRequest)                        |
| Product                          | [Product](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-products?meta=type%3AProduct)                                                    |
| ProductItem                      | [ProductItem](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-baskets?meta=type%3AProductItem)                                             |
| ProductListItem                  | [CustomerProductListItem](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-customers?meta=type%3ACustomerProductListItem)                   |
| ProductListItemReference         | [ProductListItemReference](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-customers?meta=type%3AProductListItemReference)                 |
| ProductListLink                  | [ProductListLink](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-customers?meta=type%3AProductListLink)                                   |
| ProductSearchHit                 | [ProductSearchHit](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-search?meta=type%3AProductSearchHit)                                    |
| Promotion                        | [Promotion](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-promotions?meta=type%3APromotion)                                              |
| PublicProductList                | [PublicProductList](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-customers?meta=type%3APublicProductList)                               |
| PublicProductListItem            | [PublicProductListItem](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-customers?meta=type%3APublicProductListItem)                       |
| PublicProductListLink            | [ProductListLink](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-customers?meta=type%3AProductListLink)                                   |
| Recommendation                   | [Recommendation](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-products?meta=type%3ARecommendation)                                      |
| Shipment                         | [Shipment](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-baskets?meta=type%3AShipment)                                                   |
| ShippingItem                     | [ShippingItem](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-orders?meta=type%3AShippingItem)                                            |
| ShippingMethod                   | [ShippingMethod](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-baskets?meta=type%3AShippingMethod)                                       |
| ShippingPromotion                | [ShippingPromotion](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-orders?meta=type%3AShippingPromotion)                                  |
| Store                            | [Store](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-stores?meta=type%3AStore)                                                          |
| SuggestedCategory                | [SuggestedCategory](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-search?meta=type%3ASuggestedCategory)                                  |
| SuggestedPhrase                  | [SuggestedPhrase](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-search?meta=type%3ASuggestedPhrase)                                      |
| SuggestedProduct                 | [SuggestedProduct](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-search?meta=type%3ASuggestedProduct)                                    |
| Suggestion                       | [Suggestion](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-search?meta=type%3ASuggestion)                                                |
